%define compldir %{_datadir}/bash-completion/completions/
%global upstream_major 2.37

Name:           util-linux
Version:        2.37.2
Release:        28
Summary:        A random collection of Linux utilities
License:        GPLv2 and GPLv2+ and LGPLv2+ and BSD with advertising and Public Domain
URL:            https://git.kernel.org/pub/scm/utils/util-linux/util-linux.git
Source0:        https://mirrors.edge.kernel.org/pub/linux/utils/util-linux/v%{upstream_major}/%{name}-%{version}.tar.xz
Source1:        util-linux-login.pamd
Source2:        util-linux-remote.pamd
Source3:        util-linux-chsh-chfn.pamd
Source4:        util-linux-60-raw.rules
Source5:        adjtime
Source6:        util-linux-su.pamd
Source7:        util-linux-su-l.pamd
Source8:        util-linux-runuser.pamd
Source9:        util-linux-runuser-l.pamd

Patch6000:      2.36-login-lastlog-create.patch
Patch6001:      backport-CVE-2021-3995.patch
Patch6002:      backport-CVE-2021-3996.patch
Patch6003:      realloc-buffer-when-header-size-changed.patch
Patch6004:      fix-size-use-for-stdin.patch
Patch6005:      segmentation-fault-on-invalid-unicode-input-passed-to-s-option.patch
Patch6006:      backport-fix-by-ignoring-EINVAL-on-remount-of-proc.patch
Patch6007:      backport-flush-stdout-before-reading-stdin-and-fix-uninitialized-variable.patch
Patch6008:      backport-fflush-stdout-before-reading-from-stdin.patch
Patch6009:      backport-CVE-2022-0563.patch
Patch6010:      backport-su-bash-completion-offer-usernames-rather-than-files.patch
Patch6011:      backport-Fix-memory-leaks-in-the-chcpu.patch
Patch6012:      backport-logger-fix-prio-prefix-doesn-t-use-priority-default.patch
Patch6013:      backport-vipw-flush-stdout-before-getting-answer.patch  
Patch6014:      backport-login-Restore-tty-size-after-calling-vhangup.patch
Patch6015:      backport-Forward-value-of-sector_size-instead-of-its-address.patch
Patch6016:      backport-libfdisk-dereference-of-possibly-NULL-gcc-analyzer.patch
Patch6017:      backport-libfdisk-check-calloc-return-gcc-analyzer.patch
Patch6018:      backport-mcookie-fix-infinite-loop-when-use-f.patch
Patch6019:      backport-sfdisk-write-empty-label-also-when-only-ignored-part.patch
Patch6020:      backport-fstat-dir-itself.patch
Patch6021:      backport-sfdisk-fix-typo-in-move-data-when-check-partition-size.patch
Patch6022:      backport-sysfs-fallback-for-partitions-not-including-parent-name.patch
Patch6023:      backport-libmount-all-continue-although-proc-is-not-mounted.patch
Patch6024:      backport-libblkid-don-t-mark-cache-as-probed-if-sys-not-available.patch
Patch6025:      backport-lib-path-make-path-use-more-robust-coverity-scan.patch
Patch6026:      backport-Fix-integer-overflow-for-alpha-like-linux.patch
Patch6027:      backport-last-don-t-assume-zero-terminate-strings.patch
Patch6028:      backport-script-fix-passing-args-to-execlp.patch
Patch6029:      backport-scriptlive-fix-argv-0-for-execlp.patch
Patch6030:      backport-losetup-fix-memory-leak-asan.patch
Patch6031:      backport-partx-remove-memory-leak-to-make-scanners-happy-coverity-scan.patch
Patch6032:      backport-lib-path-make-ul_path_read_buffer-more-robust-coverity-scan.patch
Patch6033:      backport-libblkid-make-blkid_free_probe-more-robust.patch
Patch6034:      backport-libmount-fix-possible-memory-leak-in-mnt_optstr_fix_secontext-coverity-scan.patch
Patch6035:      backport-lslocks-fix-maj-min-scanf.patch
Patch6036:      backport-column-don-t-require-column-name-for-JSON.patch
Patch6037:      backport-libblkid-check-fsync-return-code.patch
Patch6038:      backport-lib-strutils-improve-strtoul_or_err-for-negative-numbers.patch
Patch6039:      backport-dmesg-fix-since-and-until.patch
Patch6040:      backport-lib-allow-safe_getenv-to-work-for-non-root-users.patch
Patch6041:      backport-Maybe-there-is-a-little-mistake-in-do_taskset-functi.patch
Patch6042:      backport-loopdev-set-block_size-when-using-LOOP_CONFIGURE.patch
Patch6043:      backport-libblkid-probe-fix-size-and-offset-overflows-fuzzing.patch
Patch6044:      backport-libblkid-bsd-fix-buffer-pointer-use-fuzzing.patch
Patch6045:      backport-libblkid-mac-make-sure-block-size-is-large-enough-fuzzing.patch
Patch6046:      backport-libblkid-hfs-fix-label-use-fuzzing.patch
Patch6047:      backport-libblkid-hfs-fix-make-sure-buffer-is-large-enough.patch
Patch6048:      backport-lslogins-fix-free-invalid-pointer.patch
Patch6049:      backport-lsns-fix-the-memory-leak.patch
Patch6050:      backport-libblkid-src-topology-dm-close-redundant-write-file-.patch
Patch6051:      backport-libblkid-topology-init-variables-for-DM.patch
Patch6052:      backport-lslogins-improve-prefixes-interpretation.patch
Patch6053:      backport-lsblk-fix-endless-loop-if-device-specified-more-than-once.patch
Patch6054:      backport-libblkid-avoid-buffer-overflow-in-ocfs-superblock-parsing.patch
Patch6055:      backport-fsck-Processes-may-kill-other-processes.patch
Patch6056:      backport-fdisk-fix-output-option-parsing.patch
Patch6057:      backport-libblkid-exfat-fix-divide-by-zero-coverity-scan.patch
Patch6058:      backport-llib-pty-session-split-PTY-and-signalfd-setup.patch
Patch6059:      backport-script-fix-use-of-utempter.patch
Patch6060:      backport-logger-always-update-header-when-read-from-stdin.patch
Patch6061:      backport-libblkid-use-checksum-for-jmicron.patch
Patch6062:      backport-libblkid-cleanup-indentation.patch
Patch6063:      backport-libblkid-fix-jmicron-checksum-and-LE-to-CPU.patch
Patch6064:      backport-libblkid-fix-misaligned-address-in-probe_exfat.patch
Patch6065:      backport-ldattach-fix-intro-command-and-pause.patch
Patch6066:      backport-iso9660.h-use-more-correct-function-types.patch
Patch6067:      backport-iso9660.h-avoid-undefined-signed-integer-shift.patch
Patch6068:      backport-ipc_msg_get_limits-always-initialize-memory.patch
Patch6069:      backport-wdctl-mark-flags-field-as-unsigned-long.patch
Patch6070:      backport-login-never-send-signals-to-init.patch
Patch6071:      backport-mkswap-do-not-use-uninitialized-stack-value.patch
Patch6072:      backport-lib-pager-fix-signal-safety-issues.patch
Patch6073:      backport-libblkid-nvidia_raid-verify-superblock-size.patch
Patch6074:      backport-libblkid-nvidia_raid-validate-checksum.patch
Patch6075:      backport-libfdisk-Fix-randomly-generated-GPT-UUID-s.patch
Patch6076:      backport-write-correctly-handle-wide-characters.patch
Patch6077:      backport-wall-convert-homebrew-buffering-to-open_memstream.patch
Patch6078:      backport-wall-use-fputs_careful.patch
Patch6079:      backport-hexdump-parse-handle-truncated-format-pattern.patch
Patch6080:      backport-libblkid-copy-BLKID_PARTS_FORCE_GPT-to-whole-disk-pr.patch
Patch6081:      backport-lscpu-fix-p-output-all-caches-delimiter.patch
Patch6082:      backport-add-return-in-supam_conv-function.patch
Patch6083:      backport-wrap-return-in-else-directive-to-avoid-dead-code.patch
Patch6084:      backport-sulogin-ignore-none-existing-console-devices.patch
Patch6085:      backport-sulogin-fix-KDGKBMODE-ifdef.patch
Patch6086:      backport-unshare-Move-implementation-of-keep-caps-option-to-l.patch
Patch6087:      backport-lib-caputils-fix-integer-handling-issues-coverity-sc.patch
Patch6088:      backport-libblkid-jfs-avoid-undefined-shift.patch
Patch6089:      backport-cfdisk-add-hint-about-labels-for-bootable-flag.patch
Patch6090:      backport-logger-initialize-socket-credentials-contol-union.patch
Patch6091:      backport-column-fix-buffer-overflow-when-l-specified.patch
Patch6092:      backport-column-fix-greedy-mode-on-l.patch
Patch6093:      backport-column-fix-memory-leak.patch
Patch6094:      backport-column-fix-l.patch
Patch6095:      backport-scriptreplay-support-ctrl-s-and-ctrl-g.patch
Patch6096:      backport-login-use-correct-terminal-fd-during-setup.patch
Patch6097:      backport-login-prevent-undefined-ioctl-and-tcsetattr-calls.patch
Patch6098:      backport-libblkid-avoid-memory-leak-of-cachefile-path.patch
Patch6099:      backport-more-avoid-out-of-bound-access.patch
Patch6100:      backport-lslogins-fix-realloc-loop-allocation-size.patch
Patch6101:      backport-ldattach-don-t-call-exit-from-signal-handler.patch
Patch6102:      backport-libblkid-ntfs-validate-that-sector_size-is-a-power-o.patch
Patch6103:      backport-blkid-fix-call-to-err_exclusive_options.patch
Patch6104:      backport-libblkid-reset-errno-before-calling-probefuncs.patch
Patch6105:      backport-lib-path-fix-possible-out-of-boundary-access.patch
Patch6106:      backport-libmount-improve-mnt_table_next_child_fs.patch
Patch6107:      backport-libmount-fix-possible-NULL-dereference-coverity-scan.patch
Patch6108:      backport-libsmartcols-drop-spourious-newline-in-between-strea.patch
Patch6109:      backport-libsmartcols-flush-correct-stream.patch
Patch6110:      backport-libsmartcols-only-recognize-closed-object-as-final-e.patch
Patch6111:      backport-cal-avoid-out-of-bound-write.patch
Patch6112:      backport-libfdisk-sun-properly-initialize-partition-data.patch
Patch6113:      backport-include-c.h-add-helpers-for-unaligned-structure-acce.patch
Patch6114:      backport-libblkid-probe-read-data-in-chunks.patch
Patch6115:      backport-libblkid-avoid-aligning-out-of-probing-area.patch
Patch6116:      backport-libblkid-drbd-validate-zero-padding.patch
Patch6117:      backport-more-exit-if-POLLERR-and-POLLHUP-on-stdin-is-receive.patch
Patch6118:      backport-libblkid-hfsplus-reduce-false-positive.patch
Patch6119:      backport-wall-fix-calloc-cal-Werror-calloc-transposed-args.patch
Patch6120:      backport-libblkid-drbd-reduce-false-positive.patch
Patch6121:      backport-lib-cpuset-exit-early-from-cpulist_parse.patch
Patch6122:      backport-sys-utils-lscpu-Unblock-SIGSEGV-before-vmware_bdoor.patch
Patch6123:      backport-libblkid-Check-offset-in-LUKS2-header.patch
Patch6124:      backport-more-fix-poll-use.patch
Patch6125:      backport-CVE-2024-28085.patch

Patch9000:      Add-check-to-resolve-uname26-version-test-failed.patch
Patch9001:      SKIPPED-no-root-permissions-test.patch
%ifarch sw_64
Patch9002:      util-linux-Add-sw64-architecture.patch
%endif

BuildRequires:  audit-libs-devel >= 1.0.6 gettext-devel libselinux-devel ncurses-devel pam-devel zlib-devel popt-devel
BuildRequires:  libutempter-devel systemd-devel systemd libuser-devel libcap-ng-devel python3-devel gcc autoconf automake

Requires(post): coreutils
Requires:       pam >= 1.1.3-7, /etc/pam.d/system-auth audit-libs >= 1.0.6
Requires:       libblkid = %{version}-%{release} libmount = %{version}-%{release} libsmartcols = %{version}-%{release}
Requires:       libfdisk = %{version}-%{release} libuuid = %{version}-%{release} 

Conflicts:      initscripts < 9.79-4 bash-completion < 1:2.1-1 coreutils < 8.20 sysvinit-tools < 2.88-14
Conflicts:      e2fsprogs < 1.41.8-5 filesystem < 3

Provides:       eject = 2.1.6 rfkill = 0.5
Provides:       util-linux-ng = %{version}-%{release} hardlink = 1:1.3-9
Provides:       /bin/dmesg /bin/kill /bin/more /bin/mount /bin/umount /sbin/blkid
Provides:       /sbin/blockdev /sbin/findfs /sbin/fsck /sbin/nologin
Obsoletes:      eject <= 2.1.5 rfkill <= 0.5 util-linux-ng < 2.19 hardlink <= 1:1.3-9

%description
The util-linux package contains a random collection of files that
implements some low-level basic linux utilities.

%package -n libfdisk
Summary: Library for fdisk-like programs.
License: LGPLv2+

%description -n libfdisk
This package contains the library for fdisk-like programs.

%package -n libsmartcols
Summary: Library for column based text sort engine.
License: LGPLv2+

%description -n libsmartcols
This package contains the library for column based text sort engine.

%package -n libmount
Summary: Library for device mounting
License: LGPLv2+
Requires: libblkid = %{version}-%{release}
Requires: libuuid = %{version}-%{release}
Conflicts: filesystem < 3

%description -n libmount
This package is the library for device mounting.

%package -n libblkid
Summary: Library for block device id.
License: LGPLv2+
Requires: libuuid = %{version}-%{release}
Conflicts: filesystem < 3
Requires(post): coreutils

%description -n libblkid
This package is le library for block device id.

%package -n uuidd
Summary:  UUID generation daemon
Requires: libuuid = %{version}-%{release}
License: GPLv2
Requires: systemd
Requires(pre): shadow
Requires(post): systemd-units
Requires(preun): systemd-units

%description -n uuidd
The uuidd daemon is used by the UUID library to generate universally
unique identifiers (UUIDs), especially time-based UUIDs, in a secure
and guaranteed-unique fashion, even in the face of large numbers of
threads running on different CPUs trying to grab UUIDs.

%package -n libuuid
Summary: Universally unique ID library
License: BSD
Conflicts: filesystem < 3

%description -n libuuid
This package is the universally unique ID library.

%package user
Summary: libuser based util-linux utilities
License: GPLv2
Requires: util-linux = %{version}-%{release}

%description user
chfn and chsh utilities with dependence on libuser

%package -n python3-libmount
Summary:        Python Package for the libmount library pack
Requires:       libmount = %{version}-%{release}
License:        LGPLv2+

%description -n python3-libmount
This package provides python support for users to use the libmount library
to work with mount tables and mount filesystems.

%package devel
Summary:        Development package for ${name}
License:        LGPLv2+ and BSD
Requires:       %{name} = %{version}-%{release} pkgconfig
Provides:       libfdisk-devel libsmartcols-devel libmount-devel libblkid-devel libuuid-devel
Obsoletes:      libfdisk-devel libsmartcols-devel libmount-devel libblkid-devel libuuid-devel

%description devel
This package contains some library and other necessary files for the
development of %{name}.

%package help
Summary:        Help package for ${name}
BuildArch:      noarch
Requires:       %{name} = %{version}-%{release}
Obsoletes:      hardlink-help <= 1:1.3-9
Provides:       hardlink-help = 1:1.3-9

%description help
This package contains some doc and man help files for %{name}.

%prep
%autosetup -n %{name}-%{version} -p1

%build
%define _build_arg0__ CFLAGS="-D_LARGEFILE_SOURCE -D_LARGEFILE64_SOURCE -D_FILE_OFFSET_BITS=64 $RPM_OPT_FLAGS" SUID_CFLAGS="-fpie"
%define _build_arg1__ SUID_LDFLAGS="-pie -Wl,-z,relro -Wl,-z,now" DAEMON_CFLAGS="$SUID_CFLAGS" DAEMON_LDFLAGS="$SUID_LDFLAGS"
autoreconf

unset LINGUAS || :
# del support enable-raw  https://github.com/torvalds/linux/commit/603e4922f1c81fc2ed3a87b4f91a8d3aafc7e093
%configure \
  --with-systemdsystemunitdir=%{_unitdir} \
  --disable-silent-rules \
  --disable-bfs \
  --disable-pg \
  --enable-chfn-chsh \
  --enable-usrdir-path \
  --enable-write \
  --disable-raw \
  --enable-hardlink \
  --with-python=3 \
  --with-systemd \
  --with-udev \
  --with-selinux \
  --with-audit \
  --with-utempter \
  --disable-makeinstall-chown

%make_build %{_build_arg0__} %{_build_arg1__}

%check
export TS_OPT_misc_setarch_known_fail="yes"
make check

%install
%make_install

install -d %{buildroot}%{_sysconfdir}/pam.d
install -d %{buildroot}{/run/uuidd,/var/lib/libuuid,/var/log}

install -m644 %{SOURCE1} %{buildroot}%{_sysconfdir}/pam.d/login
install -m644 %{SOURCE2} %{buildroot}%{_sysconfdir}/pam.d/remote
install -m644 %{SOURCE3} %{buildroot}%{_sysconfdir}/pam.d/chsh
install -m644 %{SOURCE3} %{buildroot}%{_sysconfdir}/pam.d/chfn
install -Dm644 %{SOURCE4} %{buildroot}%{_prefix}/lib/udev/rules.d/60-raw.rules
install -m644 %{SOURCE5} %{buildroot}%{_sysconfdir}/adjtime
install -m644 %{SOURCE6} %{buildroot}%{_sysconfdir}/pam.d/su
install -m644 %{SOURCE7} %{buildroot}%{_sysconfdir}/pam.d/su-l
install -m644 %{SOURCE8} %{buildroot}%{_sysconfdir}/pam.d/runuser
install -m644 %{SOURCE9} %{buildroot}%{_sysconfdir}/pam.d/runuser-l

ln -sf hwclock %{buildroot}%{_sbindir}/clock
ln -sf ../proc/self/mounts %{buildroot}/etc/mtab

touch %{buildroot}/var/log/lastlog
chmod 0644 %{buildroot}/var/log/lastlog

echo ".so man8/hwclock.8" > %{buildroot}%{_mandir}/man8/clock.8

%find_lang %name

find  %{buildroot}%{_bindir}/ -regextype posix-egrep -type l \
  -regex ".*(linux32|linux64|aarch64|i386|x86_64|uname26)$" \
  -printf "%{_bindir}/%f\n" > %{name}.files
cat %{name}.lang >> %{name}.files

find  %{buildroot}%{_mandir}/man8 -regextype posix-egrep  \
  -regex ".*(linux32|linux64|aarch64|i386|x86_64|uname26)\.8.*" \
  -printf "%{_mandir}/man8/%f*\n" > %{name}-help.files

rm -rf %{buildroot}%{_libdir}/*.{la,a}
rm -rf %{buildroot}%{_libdir}/python*/site-packages/*.{la,a}

%pre -n uuidd
getent group uuidd >/dev/null || groupadd -r uuidd
getent passwd uuidd >/dev/null || \
useradd -r -g uuidd -d /var/lib/libuuid -s /sbin/nologin \
    -c "UUID generator helper daemon" uuidd
exit 0

%post
[ -d /var/log ] || mkdir -p /var/log

touch /var/log/lastlog
chown root:root /var/log/lastlog
chmod 0644 /var/log/lastlog

if [ -x /usr/sbin/selinuxenabled ] && /usr/sbin/selinuxenabled
then
    SECXT=`/usr/sbin/matchpathcon -n /var/log/lastlog 2> /dev/null`
    if [ -n "$SECXT" ]
    then
        /usr/bin/chcon "$SECXT"  /var/log/lastlog >/dev/null 2>&1 || :
    fi
fi
if [ ! -L /etc/mtab ]
then
    ln -sf ../proc/self/mounts /etc/mtab || :
fi

%post -n libblkid 
/sbin/ldconfig

[ -d /run/blkid ] || mkdir -p /run/blkid
for i in /etc/blkid.tab /etc/blkid.tab.old \
  /etc/blkid/blkid.tab /etc/blkid/blkid.tab.old
do
    if [ -f "${i}" ]
    then
        mv "${i}" /run/blkid/ || :
    fi
done

%postun -n libblkid -p /sbin/ldconfig

%post -n libuuid -p /sbin/ldconfig
%postun -n libuuid -p /sbin/ldconfig

%post -n libmount -p /sbin/ldconfig
%postun -n libmount -p /sbin/ldconfig

%post -n libsmartcols -p /sbin/ldconfig
%postun -n libsmartcols -p /sbin/ldconfig

%post -n libfdisk -p /sbin/ldconfig
%postun -n libfdisk -p /sbin/ldconfig

%post -n uuidd
%systemd_post uuidd
if [ $1 -eq 1 ]
then
    /bin/systemctl start uuidd > /dev/null 2>&1 || :
fi

%preun -n uuidd
%systemd_preun uuidd

%postun -n uuidd
/sbin/ldconfig
%systemd_postun_with_restart uuidd

%files -f %{name}.files
%exclude %{compldir}/{mount,umount}
%{!?_licensedir:%global license %%doc}
%license Documentation/licenses/* AUTHORS
%config(noreplace) %{_sysconfdir}/pam.d/{login,remote,su,su-l,runuser,runuser-l}
%config(noreplace) %{_prefix}/lib/udev/rules.d/60-raw.rules
%config(noreplace) %verify(not md5 mtime size) %{_sysconfdir}/adjtime
%attr(4755,root,root) %{_bindir}/mount
%attr(4755,root,root) %{_bindir}/umount
%attr(4755,root,root) %{_bindir}/su
%attr(755,root,root) %{_bindir}/login
%attr(2755,root,tty) %{_bindir}/write
%attr(2555,root,tty) %{_bindir}/wall
%ghost %attr(0644,root,root) %verify(not md5 size mtime) /var/log/lastlog
%ghost %verify(not md5 size mtime) %config(noreplace,missingok) /etc/mtab
%{_unitdir}/fstrim.*
%{_bindir}/{cal,chrt,col,colcrt,colrm,column,chmem,dmesg,eject,fallocate,fincore,findmnt,choom,uclampset}
%{_bindir}/{flock,getopt,hexdump,ionice,ipcmk,ipcrm,ipcs,isosize,kill,last,lastb,logger,hardlink}
%{_bindir}/{look,lsblk,lscpu,lsipc,lslocks,lslogins,lsmem,lsns,mcookie,mesg,more,mountpoint}
%{_bindir}/{namei,nsenter,prlimit,rename,renice,rev,script,scriptreplay,setarch,setpriv}
%{_bindir}/{setsid,setterm,taskset,ul,unshare,utmpdump,uuidgen,uuidparse,wdctl,whereis,scriptlive,irqtop,lsirq}
%{_sbindir}/{addpart,agetty,blkdiscard,blkid,blkzone,blockdev,chcpu,ctrlaltdel,delpart,fdisk}
%{_sbindir}/{findfs,fsck,fsck.cramfs,fsck.minix,fsfreeze,fstrim,ldattach,losetup,mkfs,mkfs.cramfs}
%{_sbindir}/{mkfs.minix,mkswap,nologin,partx,pivot_root,readprofile,resizepart,rfkill,rtcwake}
%{_sbindir}/{runuser,sulogin,swaplabel,swapoff,swapon,switch_root,wipefs,zramctl}
%{_sbindir}/{clock,fdformat,hwclock,cfdisk,sfdisk}
%{compldir}/{addpart,blkdiscard,blkid,blkzone,blockdev,cal,chcpu,chmem,chrt,col}
%{compldir}/{colcrt,colrm,column,ctrlaltdel,delpart,dmesg,eject,fallocate,fdisk}
%{compldir}/{fincore,findfs,findmnt,flock,fsck,fsck.cramfs,fsck.minix,fsfreeze}
%{compldir}/{fstrim,getopt,hexdump,ionice,ipcmk,ipcrm,ipcs,isosize,last,ldattach}
%{compldir}/{logger,look,losetup,lsblk,lscpu,lsipc,lslocks,lslogins,lsmem,lsns}
%{compldir}/{mcookie,mesg,mkfs,mkfs.cramfs,mkfs.minix,mkswap,more,mountpoint}
%{compldir}/{namei,nsenter,partx,pivot_root,prlimit,readprofile,rename,renice}
%{compldir}/{resizepart,rev,rfkill,rtcwake,runuser,script,scriptreplay,setarch}
%{compldir}/{setpriv,setsid,setterm,su,swaplabel,swapoff,swapon,taskset,ul,unshare}
%{compldir}/{utmpdump,uuidgen,uuidparse,wall,wdctl,whereis,wipefs,write,zramctl}
%{compldir}/{fdformat,hwclock,cfdisk,sfdisk,scriptlive,irqtop,lsirq,hardlink,uclampset}

%files -n libfdisk
%license Documentation/licenses/COPYING.LGPL-2.1* libfdisk/COPYING
%{_libdir}/libfdisk.so.*

%files -n libsmartcols
%license Documentation/licenses/COPYING.LGPL-2.1* libsmartcols/COPYING
%{_libdir}/libsmartcols.so.*

%files -n libmount
%license Documentation/licenses/COPYING.LGPL-2.1* libmount/COPYING
%{_libdir}/libmount.so.*

%files -n libblkid
%doc libblkid/COPYING
%{_libdir}/libblkid.so.*

%files -n uuidd
%license Documentation/licenses/COPYING.GPL-2.0*
%{_sbindir}/uuidd
%{_unitdir}/uuidd.*
%dir %attr(2775, uuidd, uuidd) /var/lib/libuuid
%dir %attr(2775, uuidd, uuidd) /run/uuidd
%{compldir}/uuidd

%files -n libuuid
%license Documentation/licenses/COPYING.BSD-3* libuuid/COPYING
%{_libdir}/libuuid.so.*

%files user
%config(noreplace)	%{_sysconfdir}/pam.d/chfn
%config(noreplace)	%{_sysconfdir}/pam.d/chsh
%attr(4711,root,root)	%{_bindir}/chfn
%attr(4711,root,root)	%{_bindir}/chsh
%{compldir}/chfn
%{compldir}/chsh

%files -n python3-libmount
%{!?_licensedir:%global license %%doc}
%license libmount/COPYING
%{_libdir}/python*/site-packages/libmount/

%files devel
%{_includedir}/{libfdisk,libsmartcols,uuid,blkid,libmount}
%{_libdir}/{libfdisk.so,libsmartcols.so,libuuid.so,libblkid.so,libmount.so}
%{_libdir}/pkgconfig/{fdisk.pc,smartcols.pc,uuid.pc,blkid.pc,mount.pc}

%files help
%exclude %{_datadir}/doc/util-linux/getopt/*
%{_docdir}/%{name}/getopt-example.*
%doc README NEWS Documentation/deprecated.txt
%doc %attr(0644,-,-) misc-utils/getopt-*.{bash,tcsh}
%{_mandir}/man1/{chfn.1*,chsh.1*,cal.1*,chrt.1*,col.1*,colcrt.1*,colrm.1*,column.1*,dmesg.1*,eject.1*,uclampset.1*}
%{_mandir}/man1/{fallocate.1*,fincore.1*,flock.1*,getopt.1*,hexdump.1*,ionice.1*,ipcmk.1*,ipcrm.1*,ipcs.1*}
%{_mandir}/man1/{kill.1*,last.1*,lastb.1*,logger.1*,login.1*,look.1*,lscpu.1*,lsipc.1*,lslogins.1*,lsmem.1*}
%{_mandir}/man1/{mcookie.1*,mesg.1*,more.1*,mountpoint.1*,namei.1*,nsenter.1*,prlimit.1*,rename.1*,renice.1*}
%{_mandir}/man1/{rev.1*,runuser.1*,script.1*,scriptreplay.1*,setpriv.1*,setsid.1*,setterm.1*,su.1*,taskset.1*}
%{_mandir}/man1/{ul.1*,unshare.1*,utmpdump.1.gz,uuidgen.1*,uuidparse.1*,wall.1*,whereis.1*,write.1*,choom.1*,scriptlive*,hardlink.1*,irqtop.1*,lsirq.1*}
%{_mandir}/man3/{libblkid.3*,uuid.3*,uuid_clear.3*,uuid_compare.3*,uuid_copy.3*,uuid_generate.3*,uuid_generate_random.3*}
%{_mandir}/man3/{uuid_generate_time_safe.3*,uuid_is_null.3*,uuid_parse.3*,uuid_time.3*,uuid_unparse.3*,uuid_generate_time.3*}
%{_mandir}/man5/{fstab.5*,terminal-colors.d.5*,adjtime_config.5.*}
%{_mandir}/man8/{uuidd.8*,fdformat.8*,hwclock.8*,clock.8*,cfdisk.8*,sfdisk.8*,addpart.8*,agetty.8*}
%{_mandir}/man8/{blkdiscard.8*,blkid.8*,blkzone.8*,blockdev.8*,chcpu.8*,chmem.8*,ctrlaltdel.8*,delpart.8*}
%{_mandir}/man8/{fdisk.8*,findfs.8*,findmnt.8*,fsck.8*,fsck.cramfs.8*,fsck.minix.8*,fsfreeze.8*,fstrim.8*}
%{_mandir}/man8/{isosize.8*,ldattach.8*,losetup.8*,lsblk.8*,lslocks.8*,lsns.8*,mkfs.8*,mkfs.cramfs.8*}
%{_mandir}/man8/{mkfs.minix.8*,mkswap.8*,mount.8*,nologin.8*,partx.8*,pivot_root.8*}
%{_mandir}/man8/{readprofile.8*,resizepart.8*,rfkill.8*,rtcwake.8*,setarch.8*,sulogin.8.gz,swaplabel.8*}
%{_mandir}/man8/{swapoff.8*,swapon.8*,switch_root.8*,umount.8*,wdctl.8.gz,wipefs.8*,zramctl.8*}

%changelog
* Fri Mar 29 2024 zhangyao <zhangyao108@huawei.com> - 2.37.2-28
- Type:CVE
- CVE:CVE-2024-28085
- SUG:NA
- DESC:fix CVE-2024-28085

* Mon Mar 11 2024 zhangyao <zhangyao108@huawei.com> - 2.37.2-27
- Type:bugfix
- CVE:NA
- SUG:NA
- DESC:sync community patches
       backport-sys-utils-lscpu-Unblock-SIGSEGV-before-vmware_bdoor.patch
       backport-libblkid-Check-offset-in-LUKS2-header.patch
       backport-more-fix-poll-use.patch

* Fri Mar 8 2024 zhangyao <zhangyao108@huawei.com> - 2.37.2-26
- Type:bugfix
- CVE:NA
- SUG:NA
- DESC:sync community patches
       backport-more-exit-if-POLLERR-and-POLLHUP-on-stdin-is-receive.patch
       backport-libblkid-hfsplus-reduce-false-positive.patch
       backport-wall-fix-calloc-cal-Werror-calloc-transposed-args.patch
       backport-libblkid-drbd-reduce-false-positive.patch
       backport-lib-cpuset-exit-early-from-cpulist_parse.patch

* Mon Feb 19 2024 zhangyao <zhangyao108@huawei.com> - 2.37.2-25
- Type:bugfix
- CVE:NA
- SUG:NA
- DESC:solve the issue of ext4 is incorrectly probed as drbd
        [add]backport-include-c.h-add-helpers-for-unaligned-structure-acce.patch
        backport-libblkid-probe-read-data-in-chunks.patch
        backport-libblkid-avoid-aligning-out-of-probing-area.patch
        backport-libblkid-drbd-validate-zero-padding.patch

* Tue Jan 16 2024 zhangyao <zhangyao108@huawei.com> - 2.37.2-24
- Type:bugfix
- CVE:NA
- SUG:NA
- DESC:sync community patches
	[add]backport-libsmartcols-drop-spourious-newline-in-between-strea.patch
	backport-libsmartcols-flush-correct-stream.patch
	backport-libsmartcols-only-recognize-closed-object-as-final-e.patch
	backport-cal-avoid-out-of-bound-write.patch
	backport-libfdisk-sun-properly-initialize-partition-data.patch

* Thu Dec 14 2023 zhangyao <zhangyao108@huawei.com> - 2.37.2-23
- Type:bugfix
- CVE:NA
- SUG:NA
- DESC:sync community patches
       [add]backport-scriptreplay-support-ctrl-s-and-ctrl-g.patch
       backport-login-use-correct-terminal-fd-during-setup.patch
       backport-login-prevent-undefined-ioctl-and-tcsetattr-calls.patch
       backport-libblkid-avoid-memory-leak-of-cachefile-path.patch
       backport-more-avoid-out-of-bound-access.patch
       backport-lslogins-fix-realloc-loop-allocation-size.patch
       backport-ldattach-don-t-call-exit-from-signal-handler.patch
       backport-libblkid-ntfs-validate-that-sector_size-is-a-power-o.patch
       backport-blkid-fix-call-to-err_exclusive_options.patch
       backport-libblkid-reset-errno-before-calling-probefuncs.patch
       backport-lib-path-fix-possible-out-of-boundary-access.patch
       backport-libmount-improve-mnt_table_next_child_fs.patch
       backport-libmount-fix-possible-NULL-dereference-coverity-scan.patch

* Mon Sep 4 2023 zhangyao <zhangyao108@huawei.com> - 2.37.2-22
- Type:bugfix
- CVE:NA
- SUG:NA
- DESC:sync community patches
       [add]backport-column-fix-buffer-overflow-when-l-specified.patch
       backport-column-fix-greedy-mode-on-l.patch
       backport-column-fix-memory-leak.patch
       backport-column-fix-l.patch

* Thu Aug 3 2023 zhangyao <zhangyao108@huawei.com> - 2.37.2-21
- Type:bugfix
- CVE:NA
- SUG:NA
- DESC:sync community patches
       [add]backport-libblkid-jfs-avoid-undefined-shift.patch
       backport-cfdisk-add-hint-about-labels-for-bootable-flag.patch
       backport-logger-initialize-socket-credentials-contol-union.patch

* Thu Jun 15 2023 zhangyao <zhangyao108@huawei.com> - 2.37.2-20
- Type:bugfix
- CVE:NA
- SUG:NA
- DESC:sync community patches
       [add]backport-lib-caputils-fix-integer-handling-issues-coverity-sc.patch
       backport-unshare-Move-implementation-of-keep-caps-option-to-l.patch

* Mon Jun 5 2023 zhangyao <zhangyao108@huawei.com> - 2.37.2-19
- Type:bugfix
- CVE:NA
- SUG:NA
- DESC:sync community patches
       [add]backport-libfdisk-Fix-randomly-generated-GPT-UUID-s.patch
       backport-write-correctly-handle-wide-characters.patch
       backport-wall-convert-homebrew-buffering-to-open_memstream.patch
       backport-wall-use-fputs_careful.patch
       backport-hexdump-parse-handle-truncated-format-pattern.patch
       backport-libblkid-copy-BLKID_PARTS_FORCE_GPT-to-whole-disk-pr.patch
       backport-lscpu-fix-p-output-all-caches-delimiter.patch
       backport-add-return-in-supam_conv-function.patch
       backport-wrap-return-in-else-directive-to-avoid-dead-code.patch
       backport-sulogin-ignore-none-existing-console-devices.patch
       backport-sulogin-fix-KDGKBMODE-ifdef.patch

* Fri May 12 2023 zhangyao <zhangyao108@huawei.com> - 2.37.2-18
- Type:bugfix
- CVE:NA
- SUG:NA
- DESC:Sync community patches
       [add]backport-CVE-2022-0563.patch
       backport-Fix-integer-overflow-for-alpha-like-linux.patch
       backport-column-don-t-require-column-name-for-JSON.patch
       backport-dmesg-fix-since-and-until.patch
       backport-fflush-stdout-before-reading-from-stdin.patch
       backport-flush-stdout-before-reading-stdin-and-fix-uninitialized-variable.patch
       backport-last-don-t-assume-zero-terminate-strings.patch
       backport-lib-allow-safe_getenv-to-work-for-non-root-users.patch
       backport-lib-path-make-path-use-more-robust-coverity-scan.patch
       backport-lib-strutils-improve-strtoul_or_err-for-negative-numbers.patch
       backport-libblkid-don-t-mark-cache-as-probed-if-sys-not-available.patch
       backport-libblkid-hfs-fix-make-sure-buffer-is-large-enough.patch
       backport-libblkid-make-blkid_free_probe-more-robust.patch
       backport-libmount-all-continue-although-proc-is-not-mounted.patch
       backport-loopdev-set-block_size-when-using-LOOP_CONFIGURE.patch
       backport-lslocks-fix-maj-min-scanf.patch
       backport-lslogins-fix-free-invalid-pointer.patch
       backport-script-fix-passing-args-to-execlp.patch
       backport-scriptlive-fix-argv-0-for-execlp.patch
       backport-sysfs-fallback-for-partitions-not-including-parent-name.patch

* Thu Mar 16 2023 zhangyao <zhangyao108@huawei.com> - 2.37.2-17
- Type:bugfix
- CVE:NA
- SUG:NA
- DESC:nvidia_raid: validate checksum
       [add] backport-libblkid-nvidia_raid-verify-superblock-size.patch
       backport-libblkid-nvidia_raid-validate-checksum.patch

* Wed Mar 8 2023 zhangyao <zhangyao108@huawei.com> - 2.37.2-16
- Type:bugfix
- CVE:NA
- SUG:NA
- DESC:sync community patches
       [add] backport-libblkid-fix-misaligned-address-in-probe_exfat.patch
       backport-ldattach-fix-intro-command-and-pause.patch
       backport-iso9660.h-use-more-correct-function-types.patch
       backport-iso9660.h-avoid-undefined-signed-integer-shift.patch
       backport-ipc_msg_get_limits-always-initialize-memory.patch
       backport-wdctl-mark-flags-field-as-unsigned-long.patch
       backport-login-never-send-signals-to-init.patch
       backport-mkswap-do-not-use-uninitialized-stack-value.patch
       backport-lib-pager-fix-signal-safety-issues.patch

* Wed Mar 1 2023 zhangyao <zhangyao108@huawei.com> - 2.37.2-15
- Type:bugfix
- CVE:NA
- SUG:NA
- DESC:use checksum for jmicron

* Tue Jan 31 2023 yangchenguang <yangchenguang@uniontech.com> - 2.37.2-14
- Type:bugfix
- ID:NA
- SUG:NA
- DESC: delete support enable-raw

* Sat Sep 17 2022 zhangyao <zhangyao108@huawei.com> - 2.37.2-13
- Type:bugfix
- CVE:NA
- SUG:NA
- DESC:sync community patches
       [add]backport-fsck-Processes-may-kill-other-processes.patch
       backport-fdisk-fix-output-option-parsing.patch
       backport-libblkid-exfat-fix-divide-by-zero-coverity-scan.patch
       backport-llib-pty-session-split-PTY-and-signalfd-setup.patch
       backport-script-fix-use-of-utempter.patch
       backport-logger-always-update-header-when-read-from-stdin.patch

* Mon Nov 14 2022 zhangyao<zhangyao108@hhuawei.com> - 2.37.2-12
- Type:bugfix
- ID:NA
- SUG:NA
- DESC:Sync community patches
       [add]backport-lsblk-fix-endless-loop-if-device-specified-more-than-once.patch
       backport-libblkid-avoid-buffer-overflow-in-ocfs-superblock-parsing.patch

* Tue Nov 8 2022 zhangyao<zhangyao108@hhuawei.com> - 2.37.2-11
- Type:bugfix
- ID:NA
- SUG:NA
- DESC:Sync community patches

* Wed Nov 2 2022 January <1398871225@qq.com> - 2.37.2-10
- Type:bugfix
- ID:NA
- SUG:NA
- DESC:fix fdisk command hung on read pipe when dmsetup command failed and initialize local variables
       [add]backport-libblkid-src-topology-dm-close-redundant-write-file-.patch
       backport-libblkid-topology-init-variables-for-DM.patch

* Wed Oct 26 2022 wuzx<wuzx1226@qq.com> - 2.37.2-9
- Type:feature
- CVE:NA
- SUG:NA
- DESC:Add sw64 architecture

* Sat Jul 30 2022 zhangyao<zhangyao108@hhuawei.com> - 2.37.2-8
- Type:bugfix
- ID:NA
- SUG:NA
- DESC:Sync community patches

* Thu Jun 30 2022 shangyibin<shangyibin1@h-partners.com> - 2.37.2-7
- Type:bugfix
- ID:NA
- SUG:NA
- DESC:Sync community patches

* Wed Jun 08 2022 renhongxun<renhongxun@h-partners.com> - 2.37.2-6
- Type:bugfix
- ID:NA
- SUG:NA
- DESC:move hardlink/uclampset completions from util-linux-help to util-linux

* Sat Feb 19 2022 shangyibin<shangyibin1@h-partners.com> - 2.37.2-5
- Type:bugfix
- ID:NA
- SUG:NA
- DESC:fix by ignoring EINVAL on remount of proc

* Fri Feb 18 2022 shangyibin<shangyibin1@h-partners.com> - 2.37.2-4
- Type:bugfix
- ID:NA
- SUG:NA
- DESC:realloc buffer when header size changed
       fix size use for stdin
       segmentation fault on invalid unicode input passed to -s option

* Mon Feb 14 2022 shangyibin<shangyibin1@h-partners.com> - 2.37.2-3
- Type:CVE
- ID:CVE-2021-3995 CVE-2021-3996
- SUG:NA
- DESC:fix CVE-2021-3995 CVE-2021-3996

* Mon Jan 10 2022 shangyibin <shangyibin1@huawei.com> - 2.37.2-2
- Type:bugfix
- ID:NA
- SUG:NA
- DESC:fix test fail

* Mon Dec 27 2021 tianwei <tianwei12@huawei.com> - 2.37.2-1
- Type:enhancement
- ID:NA
- SUG:NA
- DESC:update version to 2.37.2

* Tue Aug 10 2021 shixuantong<shixuantong@huawei.com> - 2.36.1-5
- Type:CVE
- ID:CVE-2021-37600
- SUG:NA
- DESC:fix CVE-2021-37600

* Thu Jul 22 2021 shixuantong<shixuantong@huawei.com> - 2.36.1-4
- Type:bugfix
- ID:NA
- SUG:NA
- DESC:remove gdb from BuildRequires

* Thu Mar 18 2021 wangchen <wangchen137@huawei.com> - 2.36.1-3
- Type:bugfix
- ID:NA
- SUG:NA
- DESC:use /sys to read all block devices

* Mon Mar 1 2021 yangzhuangzhuang <yangzhuangzhuang1@huawei.com> - 2.36.1-2
- Type:bugfix
- ID:NA
- SUG:NA
- DESC:Fix heap-buffer-overflow in fdisk_partname

* Tue Jan 26 2021 yangzhuangzhuang <yangzhuangzhuang1@huawei.com> - 2.36.1-1
- Type:enhancement
- ID:NA
- SUG:NA
- DESC:update version to 2.36.1

* Mon Jan 18 2021 Liquor <lirui130@huawei.com> - 2.36-4
- Type:bugfix
- ID:NA
- SUG:NA
- DESC:Remove pam_console dependency

* Thu Dec 17 2020 Liquor <lirui130@huawei.com> - 2.36-3
- Type:bugfix
- ID:NA
- SUG:NA
- DESC:Add check to resolve uname26-version test failed

* Sat Nov 28 2020 yangzhuangzhuang <yangzhuangzhuang1@huawei.com> - 2.36-2
- Type:enhancement
- ID:NA
- SUG:NA
- DESC:have wall not write to non-ttys(#65412)

* Mon Nov 2 2020 yangzhuangzhuang <yangzhuangzhuang1@huawei.com> - 2.36-1
- Type:enhancement
- ID:NA
- SUG:NA
- DESC:update version to 2.36

* Thu Oct 29 2020 Liquor <lirui130@huawei.com> - 2.35.2-4
- Type:requirement
- ID:NA
- SUG:NA
- DESC:remove python2

* Tue Sep 8 2020 wangchen <wangchen137@huawei.com> - 2.35.2-3
- Type:enhancement
- ID:NA
- SUG:NA
- DESC:modify the URL of Source0

* Fri Aug 28 2020 yang_zhuang_zhuang <yangzhuangzhuang1@huawei.com> - 2.35.2-2
- Type:bugfix
- ID:NA
- SUG:NA
- DESC:fix an issue that hardlink was packaged twice

* Thu Jul 23 2020 yang_zhuang_zhuang <yangzhuangzhuang1@huawei.com> - 2.35.2-1
- Type:enhancement
- ID:NA
- SUG:NA
- DESC:update version to 2.35.2

* Mon Jun 29 2020 Liquor <lirui130@huawei.com> - 2.34-9
- Type:bugfix
- ID:NA
- SUG:NA
- DESC:add misc-setarch test to "known_fail"

* Sun Mar 22 2020 openEuler Buildteam <buildteam@openeuler.org> - 2.34-8
- Type:enhancement
- ID:NA
- SUG:NA
- DESC:don not usr the hardlink by default

* Sun Mar 22 2020 openEuler Buildteam <buildteam@openeuler.org> - 2.34-7
- Type:enhancement
- ID:NA
- SUG:NA
- DESC:enable hardlink of configure

* Sat Mar 21 2020 openEuler Buildteam <buildteam@openeuler.org> - 2.34-6
- Type:enhancement
- ID:NA
- SUG:NA
- DESC:obsolete hardlink that has been merged into util-linux of 2.34

* Fri Mar 20 2020 openEuler Buildteam <buildteam@openeuler.org> - 2.34-5
- Type:enhancement
- ID:NA
- SUG:NA
- DESC:Add an entry for the HiSilicon aarch64 part tsv110 and
       use official name for HiSilicon tsv110

* Thu Mar 5 2020 openEuler Buildteam <buildteam@openeuler.org> - 2.34-4
- Type:enhancement
- ID:NA
- SUG:NA
- DESC:fix the problem of one iso can't mount directly twice by default

* Fri Feb 14 2020 openEuler Buildteam <buildteam@openeuler.org> - 2.34-3
- Type:enhancement
- ID:NA
- SUG:NA
- DESC:enable check

* Tue Jan 21 2020 openEuler Buildteam <buildteam@openeuler.org> - 2.34-2
- Type:enhancement
- ID:NA
- SUG:NA
- DESC:add subpackages

* Sun Jan 12 2020 openEuler Buildteam <buildteam@openeuler.org> - 2.34-1
- Type:enhancement
- ID:NA
- SUG:NA
- DESC:update version to 2.34

* Wed Jan 8 2020 openEuler Buildteam <buildteam@openeuler.org> - 2.32.1-5
- Type:enhancement
- ID:NA
- SUG:NA
- DESC:fix quit dialog for non-libreadline version

* Tue Dec 31 2019 openEuler Buildteam <buildteam@openeuler.org> - 2.32.1-4
- Type:enhancement
- ID:NA
- SUG:NA
- DESC:modify source

* Thu Oct 10 2019 shenyangyang<shenyangyang4@huawei.com> - 2.32.1-3
- Type:enhancement
- ID:NA
- SUG:NA
- DESC:modify license file

* Sat Sep 21 2019 huzhiyu<huzhiyu1@huawei.com> - 2.32.1-2
- Package init
